/* (This is the new BSD license.)
* Copyright (c) 2014, Chris Culy
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the name of the Chris Culy nor the 
*		names of its contributors may be used to endorse or promote 
*		products from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY Chris Culy
* ``AS IS'' AND ANY OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
* THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
* ARE DISCLAIMED. IN NO EVENT SHALL Chris Culy
* BE LIABLE FOR ANY, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
* CONSEQUENTIAL DAMAGES INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
* GOODS OR SERVICES; OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
* CAUSED AND ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR 
* TORT INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
* THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/"use strict";

var textmodel = textmodel || {};

(function() {
textmodel.RegExTextModel = function(e) {
var t = this;
var n = e;
var r = 20;
var i = /^\s/;
var s = /\s$/;
this.getItem = function(e, t, o) {
var u = [], a = [], f = [], l = [];
if (typeof e.source === "undefined" || e.source === "") {
return [ u, a, f, l ];
}
var c = "g";
if (e.ignoreCase) {
c += "i";
}
if (e.multiline) {
c += "m";
}
var h = new RegExp(e.source, c);
var p = [];
var d = [];
while ((d = h.exec(n)) !== null) {
var v = {
found: d[0]
};
v.start = d.index;
v.end = h.lastIndex;
p.push(v);
}
if (o !== null && o > 0) {
var m = d3.shuffle(d3.range(0, p.length)).slice(0, o);
p = d3.permute(p, m);
}
for (var g = 0, y = p.length; g < y; g++) {
var b = p[g];
var w = b.found;
var E = !i.test(w);
if (E && i.test(n.substring(b.start - 1, b.start))) {
E = false;
}
var S = !s.test(w);
if (S && i.test(n.substring(b.end, b.end + 1))) {
S = false;
}
var x = t;
if (E || S) {
x += 1;
}
var T = (x + 2) * r;
var N = n.substring(b.start - T - 1, b.start).split(/\s+/);
if (N[N.length - 1] === "") {
N.pop();
}
if (E && N.length > 0) {
w = N.pop() + w;
}
u[g] = N.slice(-t);
N = n.substring(b.end, b.end + T).split(/\s+/);
if (N[0] === "") {
N.shift();
}
if (S && N.length > 0) {
w += N.shift();
}
f[g] = N.slice(0, t);
a[g] = w;
l[g] = b.start;
}
return [ u, a, f, l ];
};
this.getItemAndContext = function(e, t, r) {
t = 1 * t;
var i = {};
var s = "";
if (e.ignoreCase) {
s += "i";
}
if (e.multiline) {
s += "m";
}
var o = new RegExp(e.source, s);
var u = o.exec(n.substr(t));
if (!u[0]) {
return null;
}
i.item = u[0];
var a = t - r;
var f = r;
if (t < r) {
a = 0;
f = t;
}
i.left = n.substr(a, f);
i.right = n.substr(t + i.item.length, r);
return i;
};
};
})();